HDU 1078 记忆化搜

Problem Description

FatMouse has stored some cheese in a city. The city can be considered as a square grid of dimension n: each grid location is labelled (p,q) where 0 <= p < n and 0 <= q < n. At each grid location Fatmouse has hid between 0 and 100 blocks of cheese in a hole. Now he's going to enjoy his favorite food.

FatMouse begins by standing at location (0,0). He eats up the cheese where he stands and then runs either horizontally or vertically to another location. The problem is that there is a super Cat named Top Killer sitting near his hole, so each time he can run at most k locations to get into the hole before being caught by Top Killer. What is worse -- after eating up the cheese at one location, FatMouse gets fatter. So in order to gain enough energy for his next run, he has to run to a location which have more blocks of cheese than those that were at the current hole.

Given n, k, and the number of blocks of cheese at each grid location, compute the maximum amount of cheese FatMouse can eat before being unable to move. 

Input

There are several test cases. Each test case consists of 

a line containing two integers between 1 and 100: n and k 
n lines, each with n numbers: the first line contains the number of blocks of cheese at locations (0,0) (0,1) ... (0,n-1); the next line contains the number of blocks of cheese at locations (1,0), (1,1), ... (1,n-1), and so on. 
The input ends with a pair of -1's. 

Output

For each test case output in a line the single integer giving the number of blocks of cheese collected. 

Sample Input

3 1
1 2 5
10 11 6
12 12 7
-1 -1

Sample Output

37

题意:

这是一道DP+搜索的题目,是很典型也是很好的题目。文章的大意是:FatMouse在一个N*N方格上找吃的,每一个点(x,y)上有一些吃的,FatMouse从(0,0)的位置出发去找吃的,并且每次最多走k步,在他走过的地方就可以吃掉吃的,保证吃的数量在0-100之间,而规定是他只能水平或者垂直走,而且每走一步,下一步的吃的数量是需要大于此刻所占的位置,问FatMouse最后最多可以吃多少吃的。那么因为他是可以在水平和垂直上面随便走的,所以这个DP就没有一定的方向性和子局面可以确定,所以只用DP是不好做出来的,这类采用DP+搜索的方法


#include <stdio.h>
#include <string.h>
#include <algorithm>
using namespace std;
int n,k,dp[105][105],a[105][105];
int to[4][2]={1,0,-1,0,0,1,0,-1};
int check( int x,int y){
	if(x<1||y<1||x>n||y>n)
	return 1;
	return 0;
}
int dfs(int x,int y)
{
	int i,j,l,ans=0;
	if(!dp[x][y])
	{
		for(i=1;i<=k;i++)
		{
			for(j=0;j<4;j++)
			{
				int xx=x+to[j][0]*i;
				int yy=y+to[j][1]*i;
				if(check(xx,yy))
				continue;
				if(a[xx][yy]>a[x][y])
				ans=max(ans,dfs(xx,yy));
			}
		}
		dp[x][y]=ans+a[x][y];
	}
	return dp[x][y];
}
int main(){
	int i,j;
	while(~scanf("%d%d",&n,&k),n!=-1&&k!=-1){
		for(i=1;i<=n;i++)
		for(j=1;j<=n;j++)
		scanf("%d",&a[i][j]);
		memset(dp,0,sizeof(dp));
		printf("%d\n",dfs(1,1));
	}
	return 0;
}

猜你喜欢

转载自blog.csdn.net/Harington/article/details/81985243